/**
 * WEBLAB: Service oriented integration platform for media mining and intelligence applications
 * 
 * Copyright (C) 2004 - 2012 CASSIDIAN
 * 
 * This library is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */

package org.ow2.weblab.webservices.listener.bean;

import java.io.File;
import java.util.Collection;
import java.util.List;

/**
 * Just a configuration bean (to ease tests and CXF deployment)
 * 
 * @author Jérémie Doucy, CASSIDIAN, an EADS company
 */
public class FolderListenerConfigBean {


	/**
	 * file URL pattern (to check if added or not to the FIFO)
	 */
	private String fileUrlPattern;


	/**
	 * interval between to checks in folders
	 */
	private int updateInterval;


	/**
	 * folders to be listened
	 */
	private List<File> folders;


	/**
	 * Delete file once crawled
	 */
	private boolean delete;


	/**
	 * UsageContext that should be initialised at Web Service start. defaultUsageContext is by default preinitialised even if not present here.
	 */
	private Collection<String> preInitialisedUsageContext;


	/**
	 * Whether or not to fail if an usageContext has not been initialised. If false, a new Listener will be started for each call with a new usageContext.
	 */
	private boolean failForNonInitialisedUsageContext;


	/**
	 * The default usageContext to be used when null is used as UsageContext.
	 */
	private String defaultUsageContext;


	/**
	 * Whether or not to prevent from adding monitoring
	 */
	private boolean oneShotCrawler;


	/**
	 * Shall the listener listen to sub directories
	 */
	private boolean recursive;


	public String getFileUrlPattern() {
		return this.fileUrlPattern;
	}


	public void setFileUrlPattern(final String fileUrlPattern) {
		this.fileUrlPattern = fileUrlPattern;
	}


	public int getUpdateInterval() {
		return this.updateInterval;
	}


	public void setUpdateInterval(final int updateInterval) {
		this.updateInterval = updateInterval;
	}


	public List<File> getFolders() {
		return this.folders;
	}


	public void setFolders(final List<File> folders) {
		this.folders = folders;
	}


	public boolean isDelete() {
		return this.delete;
	}


	public void setDelete(final boolean delete) {
		this.delete = delete;
	}


	public boolean isRecursive() {
		return this.recursive;
	}


	public void setRecursive(final boolean recursive) {
		this.recursive = recursive;
	}


	public boolean isFailForNonInitialisedUsageContext() {
		return this.failForNonInitialisedUsageContext;
	}


	public void setFailForNonInitialisedUsageContext(final boolean failForNonInitialisedUsageContext) {
		this.failForNonInitialisedUsageContext = failForNonInitialisedUsageContext;
	}


	public Collection<String> getPreInitialisedUsageContext() {
		return this.preInitialisedUsageContext;
	}


	public void setPreInitialisedUsageContext(final Collection<String> preInitialisedUsageContext) {
		this.preInitialisedUsageContext = preInitialisedUsageContext;
	}


	public String getDefaultUsageContext() {
		return this.defaultUsageContext;
	}


	public void setDefaultUsageContext(final String defaultUsageContext) {
		this.defaultUsageContext = defaultUsageContext;
	}


	public boolean isOneShotCrawler() {
		return this.oneShotCrawler;
	}


	public void setOneShotCrawler(final boolean oneShotCrawler) {
		this.oneShotCrawler = oneShotCrawler;
	}

}
